# Master script.
# DO NOT CHANGE THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING.

# Date code for autodownload.

versionc="13062010" # NEVER CHANGE THIS LINE OR AUTODOWNLOAD WILL BREAK.

. cfg/script.cfg # Configurarion call.

# Directory check.

if [ -z "$filesdir" ]; then

  echo "The location of the script is not set, please check your script.cfg."
  echo "Press ENTER to continue."
  read
  exit

fi

if [ -d "$filesdir" ]; then

  echo "Script location set."

else

  echo "Script location is incorrect, please check your script.cfg."
  echo "Press ENTER to continue."
  read
  exit

fi

cd "$filesdir"

# Binary file check.

echo -n "Checking the binary file..."

if [ -f "$dir"/"$process" ]; then

  echo ""$process" found."

else

  echo "Could not find the binary file, please check if the file exists and/or if the DIR folder is set correctly in your script.cfg."
  echo "Press ENTER to continue."
  read
  exit

fi

# Username check.

if [ -z "$user" ]; then

  echo "Username is not set, please check your script.cfg."
  echo "Press ENTER to continue."
  read
  exit

fi

# Dynamic Rotation value check.

if [ -n "$drotation" ]; then

  if [ "$drotation" -eq 0 ]; then

    echo "Dynamic Rotation is disabled, skipping it..."

  elif [ "$drotation" -eq 1 ]; then

    echo "Dynamic Rotation is enabled."

  else

    echo "Value for Dynamic Rotation is wrong, please check your script.cfg and set a value between 0 and 1"
    echo "Press ENTER to continue."
    read
    exit

  fi

else

  echo "Value for Dynamic Rotation is not set, please check your script.cfg and set a value between 0 and 1"
  echo "Press ENTER to continue."
  read
  exit

fi

# Check type selection error check.

if [ -n "$check" ]; then

  if [ "$check" -eq 1 ]; then

    echo -n "Check method set for normal NMap UDP port check."

    if [ -n "$nip" ]; then

      echo -n " IP: "$nip""

    else

      echo ""
      echo "Server IP for nmap check is not set, please check your script.cfg."
      echo "Press ENTER to continue."
      read
      exit

    fi

    if [ -n "$nport" ]; then

      echo " Port: "$nport""

    else

      echo ""
      echo "Server port for nmap check is not set, please check your script.cfg."
      echo "Press ENTER to continue."
      read
      exit

    fi

  elif [ "$check" -eq 2 ]; then

    echo -n "Check method set for spoofed NMap UDP port check."

    if [ -n "$nip" ]; then

      echo -n " IP: "$nip""

    else

      echo ""
      echo "Server IP for nmap check is not set, please check your script.cfg."
      echo "Press ENTER to continue."
      read
      exit

    fi

    if [ -n "$nport" ]; then

      echo -n " Port: "$nport""

    else

      echo ""
      echo "Server port for nmap check is not set, please check your script.cfg."
      echo "Press ENTER to continue."
      read
      exit

    fi

    if [ -n "$device" ]; then

      echo -n " Device: "$device""

    else

      echo ""
      echo "Device is not set, please check your script.cfg."
      echo "Press ENTER to continue."
      read
      exit

    fi

    if [ -n "$ips" ]; then

      echo " Fake IP: "$ips""

    else

      echo ""
      echo "Fake IP is not set, please check your script.cfg."
      echo "Press ENTER to continue."
      read
      exit

    fi

  else

    echo "Value for the check method is set to a wrong value, please check your script.cfg and set a value between 1 and 2."
    echo "Press ENTER to continue."
    read
    exit

  fi

else

  echo "No check method is set, please check your script.cfg and set a value between 1 and 2."
  echo "Press ENTER to continue."
  read
  exit  

fi

if [ -n "$game" ]; then

  sgame="+set fs_game "$game""  

fi

if [ -n "$cfg" ]; then

  scfg="+exec "$cfg""

fi

if [ -n "$ip" ]; then

  sip="+set net_ip "$ip""

fi

if [ -n "$port" ]; then

  sport="+set net_port "$port""

fi

serverbat="Starter.bat"

# Server BATCH starter. Check and creation.

if [ -f "$dir"/"$serverbat" ]; then

  echo "Updating Starter.bat..."
  ./rm -rf "$dir"/Starter.bat > /dev/null 2>&1
  echo "@ ECHO OFF" >> "$dir"/Starter.bat
  echo "ECHO." >> "$dir"/Starter.bat
  echo "ECHO Starting Server..." >> "$dir"/Starter.bat
  echo "call "$process" "$sgame" +set dedicated 2 "$scfg" "$sip" "$sport"" >> "$dir"/Starter.bat
  echo "ECHO." >> "$dir"/Starter.bat
  echo "ECHO Restarting Server..." >> "$dir"/Starter.bat
  echo "ECHO." >> "$dir"/Starter.bat
  echo "call Starter.bat" >> "$dir"/Starter.bat  

else

  echo "Creating Starter.bat..."
  echo "@ ECHO OFF" >> "$dir"/Starter.bat
  echo "ECHO." >> "$dir"/Starter.bat
  echo "ECHO Starting Server..." >> "$dir"/Starter.bat
  echo "call "$process" "$sgame" +set dedicated 2 "$scfg" "$sip" "$sport"" >> "$dir"/Starter.bat
  echo "ECHO." >> "$dir"/Starter.bat
  echo "ECHO Restarting Server..." >> "$dir"/Starter.bat
  echo "ECHO." >> "$dir"/Starter.bat
  echo "call Starter.bat" >> "$dir"/Starter.bat

fi

while :
do

# Dynamic Rotation call.

if [ "$drotation" -eq 1 ]; then

  ./bash.exe drotation.sh

fi

# Server process check, and Starter.bat start.

palive=`tasklist /v | ./grep "$user" | ./grep "$process"`

if [ -z "$palive" ]; then

  echo "Initializing Starter.bat..."
  cd "$dir"
  Starter.bat &
  cd "$filesdir"
  echo "========================================================================"

fi

# Server status checker start.

echo "Initializing Crash checker..."
echo "========================================================================"
./bash.exe ccheck.sh

# Sleeping. (Script restart time)

./sleep $seconds

done